/* a0 = base address of RAM for test */
/* Uses t0, t1, t2, t3, t4, t5, ra  and returns v0 */
#include "mips.h"
#include "hardware.h"

LEAF( tnetd53xx_ax5_BasicDataTest )
	.set	noreorder
        and     a0, ~3
        and     a1, ~3
        move    t0, a0
        KSEG1A( t0 )
        la      t1, patt
        li      t3, 13
        move    v0, zero
BDLP1:  lw      t4, 0(t1)
        sub     t3, t3, 1
        sw      t4, 0(t0)
        sw      t3, 4(t0)
        lw      t2, 0(t0)  
        xor     t2, t2, t4
        or      v0, v0, t2
BDER:   bne     t3, zero, BDLP1
        add     t1, t1, 4

        bne     v0, zero, bdde
        nop   
	jr      ra
        nop
bdde:   j       DispRange
        ori     t5, zero, 'D'
END( tnetd53xx_ax5_BasicDataTest )

LEAF( DispRange )
        .set noreorder
        move    t0, zero
        li      t1, 1
bdde1:  and     t2, t1, v0
        bne     t2, zero, bdde2
        sll     t1, t1, 1
        bne     t1, zero, bdde1
        add     t0, t0, 1  
      
bdde2:  li      t2, 0x80000000
        li      t1, 31
bdde3:  and     t3, t2, v0
        bne     t3, zero, bdde4
        srl     t2, t2, 1
        bne     t2, zero, bdde3
        sub     t1, t1, 1

bdde4:  move    t2, zero
        li      t4, 10
bdde5:  blt     t0, t4, bdde6
        nop
        add     t2, t2, 1
        sub     t0, t0, t4
        b       bdde5       
        nop

bdde6:  move    t3, zero
bdde7:  blt     t1, t4, bdde8
        nop
        add     t3, t3, 1
        sub     t1, t1, t4
        b       bdde7       
        nop

bdde8:  or      t0, 0x30         /* ???xx-xx t5, t3:t1, t2:t0 */
        or      t1, 0x30
        or      t2, 0x30
        or      t3, 0x30

  	li	t4, ASCII_DISP_BASE

	sb	t3, (3*ASCII_DISP_OFFSET)(t4)
	sb	t1, (4*ASCII_DISP_OFFSET)(t4)
	sb	t2, (6*ASCII_DISP_OFFSET)(t4)
	sb	t0, (7*ASCII_DISP_OFFSET)(t4)

	sb	t5, (2*ASCII_DISP_OFFSET)(t4)
        li      t1, '-'
	sb	t1, (5*ASCII_DISP_OFFSET)(t4)

        jr      ra
        nop
END( DispRange )

/* a0 = base address of RAM for test */
/* a1 = Size in bytes of RAM for test */
/* Uses t0, t1, t2, t3, t4, t5, ra  and returns v0 */
LEAF( tnetd53xx_ax5_RamAddressTest ) 
        .set    noreorder
        and     a0, ~3
        and     a1, ~3
	move	t0, a0		/* start adr */
	addu	t1, a0, a1	/* end adr */
        subu    t1, t1, 4

loop8:	sw	t0, 0(t0)
	bne	t0, t1, loop8
	addu    t0, t0, 4

/* Now read it back */
	
	move	t0, a0		/* start adr */
	move	v0, zero

loop9:	lw	t2, 0(t0)
        xor     t2, t2, t0
        or      v0, v0, t2
	bne	t0, t1, loop9
	addu	t0, t0, 4
        bne     v0, zero, RATe
        nop   
	jr      ra
        nop
RATe:   j       DispRange
        ori     t5, zero, 'A'
END( tnetd53xx_ax5_RamAddressTest )

/* a0 = base address of RAM for test */
/* a1 = Size in bytes of RAM for test */
/* Uses t0, t1, t2, t3, t4, t5, t6, ra  and returns v0 */
LEAF( tnetd53xx_ax5_RamDataTest ) 
        .set    noreorder
        and     a0, ~3
        and     a1, ~3
        move    t6, zero
        move    v0, zero

DDTlo:  move    t0, a0
        addu    t1, a0, a1
        subu    t1, t1, 4
        li      t3, 13

RDTl2:  la      t2, patt
        addu    t2, t2, t6

RDTl1:	lw      t4, 0(t2)
        sub     t3, t3, 1
        sw	t4, 0(t0)
	beq	t0, t1, RDTc1
	addu    t0, t0, 4
        bne     t3, zero, RDTl1
        addu    t2, t2, 4
        b       RDTl2
        li      t3, 13

RDTc1:  move    t0, a0
        addu    t1, a0, a1
        li      t3, 13

RDTl4:  la      t2, patt
        addu    t2, t2, t6

RDTl3:	lw      t4, 0(t2)
        lw	t5, 0(t0)
        sub     t3, t3, 1
	addu    t0, t0, 4
        xor     t4, t4, t5
	beq	t0, t1, RDTc2
        or      v0, v0, t4
        bne     t3, zero, RDTl3
        addu    t2, t2, 4
        b       RDTl4
        li      t3, 13

RDTc2:  bne     v0, zero, RDTe1
        li      t0, (1*4)
        blt     t6, t0,DDTlo
        addu    t6, t6, 4 
        beq     a2, zero, RDTe1
        li      t0, (13*4)
        blt     t6, t0,DDTlo
        nop
RDTe1:  bne     v0, zero, RDTeo
        nop
        jr      ra
        nop
RDTeo:  j       DispRange
        ori     t5, zero, 'I'
END( tnetd53xx_ax5_RamDataTest )

        .globl  patt
patt:	.word	0x55555555,0xaaaaaaaa,0x33333333,0xcccccccc
	.word   0x0f0f0f0f,0xf0f0f0f0,0x00ff00ff,0xff00ff00
	.word   0x0000ffff,0xffff0000,0x00000000,0xffffffff
        .word   0x00000000,0x55555555,0xaaaaaaaa,0x33333333
        .word   0xcccccccc,0x0f0f0f0f,0xf0f0f0f0,0x00ff00ff
        .word   0xff00ff00,0x0000ffff,0xffff0000,0x00000000
        .word   0xffffffff

/*----------------------------------------------------------------------*/