/* Configuration parameters */


#include "psp-usb-host-config.h"

#define USB_HOST_LITTLE_ENDIAN

#ifdef CONFIG_USB_PSP_HOST11_VBUS
#endif

#ifdef CONFIG_USB_PSP_HOST11_VLYNQ

#define	VLYNQ0_OHCI_BASE_ADDRESS	0xa4000000
#define	VLYNQ1_OHCI_BASE_ADDRESS	0xac000000
#define	V0				VLYNQ0_OHCI_BASE_ADDRESS
#define	V1				VLYNQ1_OHCI_BASE_ADDRESS

#define	VLYNQ_OHCI_CFG_BASEADDR(b)	((b)+0x00010000)
#define	VLYNQ_OHCI_CFG_RESETBASE(b)	((b)+0x00000200)
#define	VLYNQ_OHCI_CFG_CLKBASE(b)	((b)+0x00000208)
#define	VLYNQ_OHCI_CFG_ENDIANREG(b)	((b)+0x0000021c)

VLYNQ_CFG_HDR usbHostConfigTab[2]=
{
	/* definitions for Host: Vlynq0 V2U:Vlynq0 */
	{
	baseaddress	: VLYNQ_OHCI_CFG_BASEADDR(V0),		/* base of OHCI control regs */
	irq		: 4,					/* vlynq irq bit mapping */
	reset_base	: VLYNQ_OHCI_CFG_RESETBASE(V0),		/* reset control reg on V2U */
	reset_bit	: 2,					/* Host reset bit posn */
	clock_base	: VLYNQ_OHCI_CFG_CLKBASE(V0),		/* clock control reg on v2u */
	clock_val	: 0x3,					/* value to be programmed */
	endian_reg	: VLYNQ_OHCI_CFG_ENDIANREG(V0),
	endian_val	: 0x0
	}
#if 0	
	,
	/* definitions for Host:Vlynq1 V2u:Vlynq0 */
	{
	baseaddress	: VLYNQ_OHCI_CFG_BASEADDR(V1),		/* base of Ohci Control regs */
	irq		: 36,					/* vlynq irq bit mapping */
	reset_base	: VLYNQ_OHCI_CFG_RESETBASE(V1),		/* reset control reg on V2U */
	reset_bit	: 2,					/* Host reset bit posn */
	clock_base	: VLYNQ_OHCI_CFG_CLKBASE(V1),		/* clock control reg on v2u */
	clock_val	: 0x3,					/* value to be programmed */
	endian_reg	: VLYNQ_OHCI_CFG_ENDIANREG(V1),
	endian_val	: 0x0
	}
#endif	
};	


VLYNQ_CFG_HDR * usb_host_get_config()
{
	/* currently only Vlynq0 on Titan SDB supported */
	return &usbHostConfigTab[0];
}


#endif /* end of  ifdef CONFIG_USB_PSP_HOST11_VLYNQ */

