/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
#ifndef _avalanche_types_h_
#define _avalanche_types_h_

/*--- #include <asm/avalanche/generic/hal_modules/haltypes.h> ---*/
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef NULL
#define NULL (void *)0
#endif

/*------------------------------------------------------------------------------------------*\
 * Typen fr Texas GPL Module
\*------------------------------------------------------------------------------------------*/
#ifndef __UINT8_T__
typedef unsigned char   UINT8;
#define __UINT8_T__
#endif

#ifndef __UCHAR_T__
typedef unsigned char   UCHAR;
#define __UCHAR_T__
#endif

#ifndef __INT8_T__
typedef signed char     INT8;
#define __INT8_T__
#endif

#ifndef __UINT16_T__
typedef unsigned short  UINT16;
#define __UINT16_T__
#endif

#ifndef __USHORT_T__
typedef unsigned short  USHORT;
#define __USHORT_T__
#endif

#ifndef __INT16_T__
typedef signed short    INT16;
#define __INT16_T__
#endif

#ifndef __UINT32_T__
typedef unsigned int    UINT32;
#define __UINT32_T__
#endif

#ifndef __UINT_T__
typedef unsigned int    UINT;
#define __UINT_T__
#endif

#ifndef __INT32_T__
typedef signed int      INT32;
#define __INT32_T__
#endif

#ifndef __ULONG_T__
typedef unsigned long   ULONG;
#define __ULONG_T__
#endif

#ifndef __BOOL_T__
typedef int             BOOL;
#define __BOOL_T__
#endif

#ifndef __STATUS_T__
typedef int             STATUS;
#define __STATUS_T__
#endif

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
typedef void (*p_vlynq_intr_cntrl_isr_t)(void *,void *,void *);
typedef INT32 (*p_vlynq_interrupt_vector_set_t)(void *, UINT32, UINT32, INT32, INT32, INT32);
typedef INT32 (*p_vlynq_interrupt_vector_cntl_t)(void *, UINT32, INT32, UINT32);
typedef UINT32 (*p_vlynq_interrupt_get_count_t)(void *, UINT32);
typedef INT32 (*p_vlynq_install_isr_t)(void *, UINT32, p_vlynq_intr_cntrl_isr_t, void *, void *, void *);
typedef INT32 (*p_vlynq_uninstall_isr_t)(void *, UINT32, void *, void *, void *);
typedef void (*p_vlynq_root_isr_t)(void *);
typedef void (*p_vlynq_delay_t)(UINT32);
typedef INT32 (*p_vlynq_interrupt_vector_map_t)(void *, INT32, UINT32, UINT32);
typedef INT32 (*p_vlynq_interrupt_set_polarity_t)(void *, INT32, UINT32, INT32); 
typedef INT32 (*p_vlynq_interrupt_get_polarity_t)(void *, INT32, UINT32);
typedef INT32 (*p_vlynq_interrupt_set_type_t)(void *, INT32, UINT32, INT32);
typedef INT32 (*p_vlynq_interrupt_get_type_t)(void *, INT32, UINT32);
typedef INT32 (*p_vlynq_interrupt_enable_t)(void *, INT32, UINT32);
typedef INT32 (*p_vlynq_interrupt_disable_t)(void *, INT32, UINT32);
                 
/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
extern p_vlynq_interrupt_vector_set_t p_vlynq_interrupt_vector_set;
extern p_vlynq_interrupt_vector_cntl_t p_vlynq_interrupt_vector_cntl;
extern p_vlynq_interrupt_get_count_t p_vlynq_interrupt_get_count;
extern p_vlynq_install_isr_t p_vlynq_install_isr;
extern p_vlynq_uninstall_isr_t p_vlynq_uninstall_isr;
extern p_vlynq_root_isr_t p_vlynq_root_isr;
extern p_vlynq_delay_t p_vlynq_delay;
extern p_vlynq_interrupt_vector_map_t p_vlynq_interrupt_vector_map;
extern p_vlynq_interrupt_set_polarity_t p_vlynq_interrupt_set_polarity;
extern p_vlynq_interrupt_get_polarity_t p_vlynq_interrupt_get_polarity;
extern p_vlynq_interrupt_set_type_t p_vlynq_interrupt_set_type;
extern p_vlynq_interrupt_get_type_t p_vlynq_interrupt_get_type;
extern p_vlynq_interrupt_enable_t p_vlynq_interrupt_enable;
extern p_vlynq_interrupt_disable_t p_vlynq_interrupt_disable;
extern void *p_vlynqDevice0;
extern void *p_vlynqDevice1;

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
enum _avalanche_need_ {
    avalanche_need_vlynq,
    avalanche_need_auto_mdix
};

int avalanche_need(enum _avalanche_need_);

#endif /*--- #ifndef _avalanche_types_h_ ---*/
