/******************************************************************************
 * FILE PURPOSE:    Platform dependent type information Header
 ********************************************************************************
 * FILE NAME:       haltypes.h
 *
 * DESCRIPTION:     Platform dependent (tuned) types definations.
 *                  Intented to be used by HAL/Drivers etc.
 *
 * REVISION HISTORY:
 * 27 Nov 02 - PSP TII  
 *
 * (C) Copyright 2002, Texas Instruments, Inc
 *******************************************************************************/

#ifndef __HAL_TYPES_H__
#define __HAL_TYPES_H__

#if 0
typedef char    INT8;
typedef short   INT16;
typedef int     INT32;

typedef unsigned char   UINT8;
typedef unsigned short  UINT16;
typedef unsigned int    UINT32;

typedef unsigned char   UCHAR;
typedef unsigned short  USHORT;
typedef unsigned int    UINT;
typedef unsigned long   ULONG;

typedef int     BOOL;
typedef int     STATUS;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef NULL
#define NULL 0
#endif

#else
/*------------------------------------------------------------------------------------------*\
 * Typen fr Texas GPL Module
\*------------------------------------------------------------------------------------------*/
#ifndef __UINT8_T__
typedef unsigned char   UINT8;
#define __UINT8_T__
#endif

#ifndef __UCHAR_T__
typedef unsigned char   UCHAR;
#define __UCHAR_T__
#endif

#ifndef __INT8_T__
typedef signed char     INT8;
#define __INT8_T__
#endif

#ifndef __UINT16_T__
typedef unsigned short  UINT16;
#define __UINT16_T__
#endif

#ifndef __USHORT_T__
typedef unsigned short  USHORT;
#define __USHORT_T__
#endif

#ifndef __INT16_T__
typedef signed short    INT16;
#define __INT16_T__
#endif

#ifndef __UINT32_T__
typedef unsigned int    UINT32;
#define __UINT32_T__
#endif

#ifndef __UINT_T__
typedef unsigned int    UINT;
#define __UINT_T__
#endif

#ifndef __INT32_T__
typedef signed int      INT32;
#define __INT32_T__
#endif

#ifndef __ULONG_T__
typedef unsigned long   ULONG;
#define __ULONG_T__
#endif

#ifndef __BOOL_T__
typedef int             BOOL;
#define __BOOL_T__
#endif

#ifndef __STATUS_T__
typedef int             STATUS;
#define __STATUS_T__
#endif
#endif

#endif /*  __HAL_TYPES_H__ */

